[android-components](../../index.md) / [mozilla.components.browser.state.action](../index.md) / [ContentAction](./index.md)

# ContentAction

`sealed class ContentAction : `[`BrowserAction`](../-browser-action.md) [(source)](https://github.com/mozilla-mobile/android-components/blob/master/components/browser/state/src/main/java/mozilla/components/browser/state/action/BrowserAction.kt#L131)

[BrowserAction](../-browser-action.md) implementations related to updating the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) of a single [SessionState](../../mozilla.components.browser.state.state/-session-state/index.md) inside
[BrowserState](../../mozilla.components.browser.state.state/-browser-state/index.md).

### Types

| Name | Summary |
|---|---|
| [AddFindResultAction](-add-find-result-action/index.md) | `data class AddFindResultAction : `[`ContentAction`](./index.md)<br>Adds a [FindResultState](../../mozilla.components.browser.state.state.content/-find-result-state/index.md) to the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-add-find-result-action/session-id.md). |
| [ClearFindResultsAction](-clear-find-results-action/index.md) | `data class ClearFindResultsAction : `[`ContentAction`](./index.md)<br>Removes all [FindResultState](../../mozilla.components.browser.state.state.content/-find-result-state/index.md)s of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-clear-find-results-action/session-id.md). |
| [ConsumeDownloadAction](-consume-download-action/index.md) | `data class ConsumeDownloadAction : `[`ContentAction`](./index.md)<br>Removes the [DownloadState](../../mozilla.components.browser.state.state.content/-download-state/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-consume-download-action/session-id.md). |
| [ConsumeHitResultAction](-consume-hit-result-action/index.md) | `data class ConsumeHitResultAction : `[`ContentAction`](./index.md)<br>Removes the [HitResult](../../mozilla.components.concept.engine/-hit-result/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-consume-hit-result-action/session-id.md). |
| [ConsumePromptRequestAction](-consume-prompt-request-action/index.md) | `data class ConsumePromptRequestAction : `[`ContentAction`](./index.md)<br>Removes the [PromptRequest](../../mozilla.components.concept.engine.prompt/-prompt-request/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-consume-prompt-request-action/session-id.md). |
| [ConsumeWindowRequestAction](-consume-window-request-action/index.md) | `data class ConsumeWindowRequestAction : `[`ContentAction`](./index.md)<br>Removes the [WindowRequest](../../mozilla.components.concept.engine.window/-window-request/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-consume-window-request-action/session-id.md). |
| [RemoveIconAction](-remove-icon-action/index.md) | `data class RemoveIconAction : `[`ContentAction`](./index.md)<br>Removes the icon of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-remove-icon-action/session-id.md). |
| [RemoveThumbnailAction](-remove-thumbnail-action/index.md) | `data class RemoveThumbnailAction : `[`ContentAction`](./index.md)<br>Removes the thumbnail of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-remove-thumbnail-action/session-id.md). |
| [UpdateDownloadAction](-update-download-action/index.md) | `data class UpdateDownloadAction : `[`ContentAction`](./index.md)<br>Updates the [DownloadState](../../mozilla.components.browser.state.state.content/-download-state/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-download-action/session-id.md). |
| [UpdateHitResultAction](-update-hit-result-action/index.md) | `data class UpdateHitResultAction : `[`ContentAction`](./index.md)<br>Updates the [HitResult](../../mozilla.components.concept.engine/-hit-result/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-hit-result-action/session-id.md). |
| [UpdateIconAction](-update-icon-action/index.md) | `data class UpdateIconAction : `[`ContentAction`](./index.md)<br>Updates the icon of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-icon-action/session-id.md). |
| [UpdateLoadingStateAction](-update-loading-state-action/index.md) | `data class UpdateLoadingStateAction : `[`ContentAction`](./index.md)<br>Updates the loading state of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-loading-state-action/session-id.md). |
| [UpdateProgressAction](-update-progress-action/index.md) | `data class UpdateProgressAction : `[`ContentAction`](./index.md)<br>Updates the progress of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-progress-action/session-id.md). |
| [UpdatePromptRequestAction](-update-prompt-request-action/index.md) | `data class UpdatePromptRequestAction : `[`ContentAction`](./index.md)<br>Updates the [PromptRequest](../../mozilla.components.concept.engine.prompt/-prompt-request/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-prompt-request-action/session-id.md). |
| [UpdateSearchTermsAction](-update-search-terms-action/index.md) | `data class UpdateSearchTermsAction : `[`ContentAction`](./index.md)<br>Updates the search terms of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-search-terms-action/session-id.md). |
| [UpdateSecurityInfoAction](-update-security-info-action/index.md) | `data class UpdateSecurityInfoAction : `[`ContentAction`](./index.md)<br>Updates the [SecurityInfoState](../../mozilla.components.browser.state.state/-security-info-state/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-security-info-action/session-id.md). |
| [UpdateThumbnailAction](-update-thumbnail-action/index.md) | `data class UpdateThumbnailAction : `[`ContentAction`](./index.md)<br>Updates the thumbnail of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-thumbnail-action/session-id.md). |
| [UpdateTitleAction](-update-title-action/index.md) | `data class UpdateTitleAction : `[`ContentAction`](./index.md)<br>Updates the title of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-title-action/session-id.md). |
| [UpdateUrlAction](-update-url-action/index.md) | `data class UpdateUrlAction : `[`ContentAction`](./index.md)<br>Updates the URL of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-url-action/session-id.md). |
| [UpdateWindowRequestAction](-update-window-request-action/index.md) | `data class UpdateWindowRequestAction : `[`ContentAction`](./index.md)<br>Updates the [WindowRequest](../../mozilla.components.concept.engine.window/-window-request/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-window-request-action/session-id.md). |

### Extension Functions

| Name | Summary |
|---|---|
| [loadResourceAsString](../../mozilla.components.support.test.file/kotlin.-any/load-resource-as-string.md) | `fun `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`.loadResourceAsString(path: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`): `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)<br>Loads a file from the resources folder and returns its content as a string object. |

### Inheritors

| Name | Summary |
|---|---|
| [AddFindResultAction](-add-find-result-action/index.md) | `data class AddFindResultAction : `[`ContentAction`](./index.md)<br>Adds a [FindResultState](../../mozilla.components.browser.state.state.content/-find-result-state/index.md) to the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-add-find-result-action/session-id.md). |
| [ClearFindResultsAction](-clear-find-results-action/index.md) | `data class ClearFindResultsAction : `[`ContentAction`](./index.md)<br>Removes all [FindResultState](../../mozilla.components.browser.state.state.content/-find-result-state/index.md)s of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-clear-find-results-action/session-id.md). |
| [ConsumeDownloadAction](-consume-download-action/index.md) | `data class ConsumeDownloadAction : `[`ContentAction`](./index.md)<br>Removes the [DownloadState](../../mozilla.components.browser.state.state.content/-download-state/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-consume-download-action/session-id.md). |
| [ConsumeHitResultAction](-consume-hit-result-action/index.md) | `data class ConsumeHitResultAction : `[`ContentAction`](./index.md)<br>Removes the [HitResult](../../mozilla.components.concept.engine/-hit-result/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-consume-hit-result-action/session-id.md). |
| [ConsumePromptRequestAction](-consume-prompt-request-action/index.md) | `data class ConsumePromptRequestAction : `[`ContentAction`](./index.md)<br>Removes the [PromptRequest](../../mozilla.components.concept.engine.prompt/-prompt-request/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-consume-prompt-request-action/session-id.md). |
| [ConsumeWindowRequestAction](-consume-window-request-action/index.md) | `data class ConsumeWindowRequestAction : `[`ContentAction`](./index.md)<br>Removes the [WindowRequest](../../mozilla.components.concept.engine.window/-window-request/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-consume-window-request-action/session-id.md). |
| [RemoveIconAction](-remove-icon-action/index.md) | `data class RemoveIconAction : `[`ContentAction`](./index.md)<br>Removes the icon of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-remove-icon-action/session-id.md). |
| [RemoveThumbnailAction](-remove-thumbnail-action/index.md) | `data class RemoveThumbnailAction : `[`ContentAction`](./index.md)<br>Removes the thumbnail of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-remove-thumbnail-action/session-id.md). |
| [UpdateDownloadAction](-update-download-action/index.md) | `data class UpdateDownloadAction : `[`ContentAction`](./index.md)<br>Updates the [DownloadState](../../mozilla.components.browser.state.state.content/-download-state/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-download-action/session-id.md). |
| [UpdateHitResultAction](-update-hit-result-action/index.md) | `data class UpdateHitResultAction : `[`ContentAction`](./index.md)<br>Updates the [HitResult](../../mozilla.components.concept.engine/-hit-result/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-hit-result-action/session-id.md). |
| [UpdateIconAction](-update-icon-action/index.md) | `data class UpdateIconAction : `[`ContentAction`](./index.md)<br>Updates the icon of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-icon-action/session-id.md). |
| [UpdateLoadingStateAction](-update-loading-state-action/index.md) | `data class UpdateLoadingStateAction : `[`ContentAction`](./index.md)<br>Updates the loading state of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-loading-state-action/session-id.md). |
| [UpdateProgressAction](-update-progress-action/index.md) | `data class UpdateProgressAction : `[`ContentAction`](./index.md)<br>Updates the progress of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-progress-action/session-id.md). |
| [UpdatePromptRequestAction](-update-prompt-request-action/index.md) | `data class UpdatePromptRequestAction : `[`ContentAction`](./index.md)<br>Updates the [PromptRequest](../../mozilla.components.concept.engine.prompt/-prompt-request/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-prompt-request-action/session-id.md). |
| [UpdateSearchTermsAction](-update-search-terms-action/index.md) | `data class UpdateSearchTermsAction : `[`ContentAction`](./index.md)<br>Updates the search terms of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-search-terms-action/session-id.md). |
| [UpdateSecurityInfoAction](-update-security-info-action/index.md) | `data class UpdateSecurityInfoAction : `[`ContentAction`](./index.md)<br>Updates the [SecurityInfoState](../../mozilla.components.browser.state.state/-security-info-state/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-security-info-action/session-id.md). |
| [UpdateThumbnailAction](-update-thumbnail-action/index.md) | `data class UpdateThumbnailAction : `[`ContentAction`](./index.md)<br>Updates the thumbnail of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-thumbnail-action/session-id.md). |
| [UpdateTitleAction](-update-title-action/index.md) | `data class UpdateTitleAction : `[`ContentAction`](./index.md)<br>Updates the title of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-title-action/session-id.md). |
| [UpdateUrlAction](-update-url-action/index.md) | `data class UpdateUrlAction : `[`ContentAction`](./index.md)<br>Updates the URL of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-url-action/session-id.md). |
| [UpdateWindowRequestAction](-update-window-request-action/index.md) | `data class UpdateWindowRequestAction : `[`ContentAction`](./index.md)<br>Updates the [WindowRequest](../../mozilla.components.concept.engine.window/-window-request/index.md) of the [ContentState](../../mozilla.components.browser.state.state/-content-state/index.md) with the given [sessionId](-update-window-request-action/session-id.md). |
